package com.xinelu.manage.domain.consultationInfo;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.xinelu.common.annotation.Excel;
import com.xinelu.common.core.domain.BaseEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import java.io.Serializable;
import java.time.LocalTime;
import java.util.Date;

/**
 * 在线问诊-问诊信息（图文和视频问诊基本信息）对象 consultation_info
 *
 * @author xinelu
 * @date 2023-09-25
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "在线问诊-问诊信息（图文和视频问诊基本信息）对象", description = "consultation_info")
public class ConsultationInfo extends BaseEntity implements Serializable {

    private static final long serialVersionUID = -8367271791868621123L;
    /**
     * id
     */
    private Long id;

    /**
     * 患者id
     */
    @ApiModelProperty(value = "患者id")
    @Excel(name = "患者id")
    private Long patientId;

    /**
     * 患者名称
     */
    @ApiModelProperty(value = "患者名称")
    @Excel(name = "患者名称")
    private String patientName;

    /**
     * 患者身份证号
     */
    @ApiModelProperty(value = "患者身份证号")
    @Excel(name = "患者身份证号")
    private String cardNo;

    /**
     * 患者联系方式
     */
    @ApiModelProperty(value = "患者联系方式")
    @Excel(name = "患者联系方式")
    private String phone;

    /**
     * 现住址所在地区
     */
    @ApiModelProperty(value = "现住址所在地区")
    @Excel(name = "现住址所在地区")
    private String address;

    /**
     * 医生id(签约医生/专家)
     */
    @ApiModelProperty(value = "医生id(签约医生/专家)")
    @Excel(name = "医生id(签约医生/专家)")
    private String doctorId;

    /**
     * 医生名称
     */
    @ApiModelProperty(value = "医生名称")
    @Excel(name = "医生名称")
    private String doctorName;

    /**
     * 问诊类型，图文问诊：IMAGE_TEXT_CONSULTATION，视频问诊：VIDEO_CONSULTATION
     */
    @ApiModelProperty(value = "问诊类型，图文问诊：IMAGE_TEXT_CONSULTATION，视频问诊：VIDEO_CONSULTATION")
    @Excel(name = "问诊类型，图文问诊：IMAGE_TEXT_CONSULTATION，视频问诊：VIDEO_CONSULTATION")
    private String consultationType;

    /**
     * 状态(1 未完成 ,2 已完成)
     */
    @ApiModelProperty(value = "状态(1 未完成 ,2 已完成)")
    @Excel(name = "状态(1 未完成 ,2 已完成)")
    private Integer status;

    /**
     * 预约日期(视频问诊预约)，时间格式：yyyy-MM-dd
     */
    @ApiModelProperty(value = "预约日期(视频问诊预约)，时间格式：yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "预约日期(视频问诊预约)，时间格式：yyyy-MM-dd", width = 30, dateFormat = "yyyy-MM-dd")
    private Date appointmentDate;

    /**
     * 预约开始时间点(视频问诊预约)，时间格式：HH:mm
     */
    @ApiModelProperty(value = "预约开始时间点(视频问诊预约)，时间格式：HH:mm")
    @JsonFormat(pattern = "HH:mm")
    private LocalTime appointmentStartTime;

    /**
     * 预约结束时间点(视频问诊预约)，时间格式：HH:mm
     */
    @ApiModelProperty(value = "预约结束时间点(视频问诊预约)，时间格式：HH:mm")
    @JsonFormat(pattern = "HH:mm")
    private LocalTime appointmentEndTime;

    /**
     * 视频问诊地址
     */
    @ApiModelProperty(value = "视频问诊地址")
    @Excel(name = "视频问诊地址")
    private String videoUrl;

    /**
     * 问题简述
     */
    @ApiModelProperty(value = "问题简述")
    @Excel(name = "问题简述")
    private String problemDescription;

    /**
     * 患者个体情况说明
     */
    @ApiModelProperty(value = "患者个体情况说明")
    @Excel(name = "患者个体情况说明")
    private String situationDescription;

    /**
     * 问题描述
     */
    @ApiModelProperty(value = "问题描述")
    @Excel(name = "问题描述")
    private String problemStatement;

    /**
     * 病历
     */
    @ApiModelProperty(value = "病历")
    @Excel(name = "病历")
    private String medicalRecord;

	@ApiModelProperty(value = "预约班次明细表主键")
	private Long schedulePlanDetailId;

    /**
     * 是否删除标识，0：否，1：是
     */
    private Integer delFlag;

    @Override
    public String toString() {
        return new ToStringBuilder(this, ToStringStyle.MULTI_LINE_STYLE)
                .append("id", getId())
                .append("patientId", getPatientId())
                .append("patientName", getPatientName())
                .append("cardNo", getCardNo())
                .append("phone", getPhone())
                .append("address", getAddress())
                .append("doctorId", getDoctorId())
                .append("doctorName", getDoctorName())
                .append("consultationType", getConsultationType())
                .append("status", getStatus())
                .append("appointmentDate", getAppointmentDate())
                .append("appointmentStartTime", getAppointmentStartTime())
                .append("appointmentEndTime", getAppointmentEndTime())
                .append("videoUrl", getVideoUrl())
                .append("problemDescription", getProblemDescription())
                .append("situationDescription", getSituationDescription())
                .append("problemStatement", getProblemStatement())
                .append("medicalRecord", getMedicalRecord())
	            .append("schedulePlanDetailId", getSchedulePlanDetailId())
                .append("delFlag", getDelFlag())
                .append("createBy", getCreateBy())
                .append("createTime", getCreateTime())
                .append("updateBy", getUpdateBy())
                .append("updateTime", getUpdateTime())
                .toString();
    }
}
